var NAVTREE =
[
  [ "libzypp", "index.html", [
    [ "Welcome to libzypp", "index.html", [
      [ "Introduction", "index.html#intro", null ],
      [ "What is libzypp?", "index.html#whatis", null ],
      [ "Implementation", "index.html#impl", null ],
      [ "Other functionality offered by libzypp", "index.html#otherfunc", null ],
      [ "3rd party software libzypp is based on", "index.html#thirdpfunc", null ],
      [ "Join the community", "index.html#join", null ],
      [ "License", "index.html#license", null ]
    ] ],
    [ "Code 12 Application Metadata", "zypp--appdata.html", [
      [ "Intro", "zypp--appdata.html#zypp-appdata_intro", null ],
      [ "Missing or wrong appdata", "zypp--appdata.html#zypp-appdata_wrong_appdata", null ]
    ] ],
    [ "Code Pitfalls - Frequently made mistakes", "CodePitfalls.html", [
      [ "Comparing TriBool values", "CodePitfalls.html#TriBoolCompare", null ]
    ] ],
    [ "Code Snippets", "CodeSnippets.html", [
      [ "for_", "CodeSnippets.html#for_", null ],
      [ "erase elements from containers", "CodeSnippets.html#erase", null ]
    ] ],
    [ "Environment Variables", "zypp-envars.html", [
      [ "Environment Variables", "zypp-envars.html#zypp-envars-intro", [
        [ "zypp config options", "zypp-envars.html#zypp-envars-config", null ],
        [ "Variables related to repositories", "zypp-envars.html#zypp-envars-repos", null ],
        [ "Variables related to commit", "zypp-envars.html#zypp-envars-commit", null ],
        [ "Variables related to logging", "zypp-envars.html#zypp-envars-logging", null ],
        [ "Selecting the mediabackend to use.", "zypp-envars.html#zypp-envars-mediabackend", null ],
        [ "Variables related to plugins", "zypp-envars.html#zypp-envars-plugin", null ],
        [ "Variables not for common use (test and debug)", "zypp-envars.html#zypp-envars-misc", null ]
      ] ]
    ] ],
    [ "Testing for provided features.", "feature-test.html", [
      [ "Introduction", "feature-test.html#intro", null ],
      [ "Features", "feature-test.html#features", null ]
    ] ],
    [ "Notes on revisions", "Notes.html", [
      [ "6.8.0 - Deprecated methods deleted", "Notes.html#V_6_8_0", null ],
      [ "6.10.0 - Removed zypp::UpgradeStatistics", "Notes.html#V_6_10_0", null ]
    ] ],
    [ "Code 12 Pattern Packages", "zypp-pattern-packages.html", [
      [ "Intro", "zypp-pattern-packages.html#zypp-pattern-packages_intro", null ]
    ] ],
    [ "Extending ZYpp: Plugins and Hooks", "zypp-plugins.html", "zypp-plugins" ],
    [ "Repository Variables", "zypp-repovars.html", [
      [ "Repository Variables", "zypp-repovars.html#zypp-repovars-intro", [
        [ "Builtin repository variables", "zypp-repovars.html#zypp-repoars-builtin", null ]
      ] ]
    ] ],
    [ "Services", "zypp-services.html", [
      [ "Classes of services", "zypp-services.html#service-types", [
        [ "Remote Services", "zypp-services.html#services-remote", null ],
        [ "Plugin Services", "zypp-services.html#services-plugin", null ]
      ] ],
      [ "Refreshing services", "zypp-services.html#service-refresh", null ],
      [ "Example usecases", "zypp-services.html#service-examples", [
        [ "Usecase #1: The project with multiple repositories and layers", "zypp-services.html#services-usecase-1", null ],
        [ "Usecase #2: Update repositories based on the customer", "zypp-services.html#services-usecase-2", null ],
        [ "Usecase #3: Dynamic repository collections", "zypp-services.html#services-usecase-3", null ]
      ] ],
      [ "Developers: Implementation", "zypp-services.html#service-impl", null ]
    ] ],
    [ "Solver - Vendor protection", "pg_zypp-solv-vendorchange.html", [
      [ "Vendor protection rule", "pg_zypp-solv-vendorchange.html#zypp-solv-vendorchange", [
        [ "The vendor protection rule is quite simple:", "pg_zypp-solv-vendorchange.html#zypp-solv-vendorchange-rule", null ]
      ] ],
      [ "Vendor protection tuning", "pg_zypp-solv-vendorchange.html#zypp-solv-vendorchange-tune", [
        [ "Groups of equivalent vendor strings", "pg_zypp-solv-vendorchange.html#zypp-solv-vendorchange-equiv", null ]
      ] ],
      [ "Related classes", "pg_zypp-solv-vendorchange.html#zypp-solv-vendorchange-Impl", null ]
    ] ],
    [ "Writing and tunning testcases", "Testcases.html", [
      [ "Introduction", "Testcases.html#Introduction", null ],
      [ "Anatomy of a ZYpp testcase", "Testcases.html#Anatomy", null ],
      [ "Building and running the testsuite", "Testcases.html#Building", null ],
      [ "References", "Testcases.html#References", null ]
    ] ],
    [ "Libzypp and threads", "thread.html", [
      [ "Libzypp and threads", "thread.html#thread_intro", [
        [ "Logging in threads", "thread.html#thread_loggin", null ]
      ] ]
    ] ],
    [ "User data as transaction id", "zypp-userdata.html", [
      [ "Introduction", "zypp-userdata.html#userdata-introduction", null ]
    ] ],
    [ "Todo List", "todo.html", null ],
    [ "Deprecated List", "deprecated.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", "namespacemembers_dup" ],
        [ "Functions", "namespacemembers_func.html", "namespacemembers_func" ],
        [ "Variables", "namespacemembers_vars.html", null ],
        [ "Typedefs", "namespacemembers_type.html", null ],
        [ "Enumerations", "namespacemembers_enum.html", null ],
        [ "Enumerator", "namespacemembers_eval.html", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", "functions_type" ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", "functions_eval" ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", null ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"APIConfig_8h.html",
"DefaultLoadSystem_8cc_source.html",
"IdStringType_8h.html#a436a86d2181c5393196d796d4f908af1",
"Map_8h.html",
"OnMediaLocation_8cc_source.html",
"PoolMember_8h.html#a2a97e91d68e8cac5d426e660632040ad",
"RepoInfoBase_8cc.html",
"RpmFlags_8h_source.html",
"String_8cc.html#a373348b9a30f37f621d196a64bd18454",
"Transaction_8cc_source.html",
"classtmsEmpty.html",
"classzypp_1_1Capabilities_1_1const__iterator.html#a2de7943a55d3b57b737b4511db2f02ce",
"classzypp_1_1CpeId_1_1Value.html#a372b701ebd28a03d5249c67eee8f8668",
"classzypp_1_1Exception.html#af5f2bb21780f01a605397a29b800ef6c",
"classzypp_1_1IdString.html#a120f1c3ae14a971b06c591c4f339ba62",
"classzypp_1_1Locks_1_1Impl.html",
"classzypp_1_1Patch_1_1ReferenceIterator.html#a0a4752b9dbb8501671f39ad9ac90c3c1",
"classzypp_1_1PoolQuery.html#a6e1a80fdf94d277b3b96e5780f7b345a",
"classzypp_1_1PublicKey.html#a8599f571db5a6e3c2b7a6adc7787360e",
"classzypp_1_1Repository.html#a51537ecd1e7c8b36060cbecbce3317f3",
"classzypp_1_1ResStatus.html#a25e51b343d17948121317036165a016b",
"classzypp_1_1SerialNumberWatcher.html#a64c7c54d551359fd204731549e35a723",
"classzypp_1_1Url.html#af49560adc47305afdee5898509c61c27",
"classzypp_1_1ZYppCommitResult.html#a91d921dfc8c40a6cb316b891def80023",
"classzypp_1_1bit_1_1BitField.html#a1c3a4750c11d2c75b21d4dc29e9686da",
"classzypp_1_1filesystem_1_1PathInfo.html#a442c087897e6f58682e2a68f018e7312",
"classzypp_1_1media_1_1AttachPoint.html#ad68218d64e73af4f3bb2486f3eeb12c3",
"classzypp_1_1media_1_1MediaCurl.html#a5d3e048bf290d6fd2f06ff5724f32796",
"classzypp_1_1media_1_1MediaMultiCurl.html#a0a0c9d649bb21981468db2a131047009",
"classzypp_1_1media_1_1TransferSettings.html#a86adcddb2b4202627775789ea5777dc3",
"classzypp_1_1parser_1_1ProductFileData.html#a4ddde9d124cc9bc958102fcc9667635e",
"classzypp_1_1repo_1_1RepoException.html",
"classzypp_1_1sat_1_1LookupAttr.html#a79feead4d152c8bc6d863f95837edd66",
"classzypp_1_1sat_1_1SolvAttr.html#a145dec0cd1964257464da4b1cffda4e8",
"classzypp_1_1sat_1_1Transaction.html#a77de9aa4b085107c22927285e578e22f",
"classzypp_1_1solver_1_1detail_1_1SolverQueueItemDelete.html#ae9db8d3b723d6973647f859c7a341c97",
"classzypp_1_1target_1_1RpmPostTransCollector.html#a56d81c20b8750468336c907268bfcce3",
"classzypp_1_1target_1_1rpm_1_1RpmDb.html#a0347532d203b946236e07d6bc581d122",
"classzypp_1_1target_1_1rpm_1_1librpmDb_1_1DbDirInfo.html#aa773b1f4072b5cc3643a7c48f0867247",
"classzypp_1_1url_1_1UrlBase.html#ae2b5d38d8be3141528f26efab4640487",
"classzypp_1_1zypp__detail_1_1ZYppImpl.html#af57bf2ad504d9a8c9555d916b5a78120",
"group__LOGICALFILTERS.html#ga9a7c3b6d367453248dc939ce92851f2d",
"namespacezypp_1_1HACK.html",
"structzypp_1_1CleanEmptyLocksReport.html#a4add369aef9c0d49ee0fb8f3d99b1e65",
"structzypp_1_1HistoryActionID.html#a88d13d8ce761da89f7db7f6575dd7c41a1bf7541cd353bf7c4b9aef58c542c0d8",
"structzypp_1_1PoolQueryAttr.html#a085a77cb6116d35525b8d936e41da0fd",
"structzypp_1_1RepoInfo_1_1Impl.html#af9d91d2ab35bc884c5803f7dd2239787",
"structzypp_1_1__logtoolsdetail_1_1DumpMap_1_1Transformer.html",
"structzypp_1_1functor_1_1Collector.html#ab2bb1f63eef6d356eda1275b59305602",
"structzypp_1_1media_1_1ml__parsedata.html#aa526481507e71958b94dd2b5cd81dc3f",
"structzypp_1_1repo_1_1yum_1_1ResourceType.html#a1fa7b0c33873c52e32d51a968e590879",
"structzypp_1_1solver_1_1detail_1_1FindPackage.html#a49c143c18bf8ebdb81326afa9ff0b67f",
"structzypp_1_1ui_1_1Selectable_1_1Impl.html#aa1d76a956b3694dcc87757ff8cb335ee",
"zypp-services.html#services-plugin"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,window.location.hash,relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })
}

